﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Football
{
    abstract class AgentPlayer
    {
        protected PointF intendedVelocity, intendedBallVelocity;
        protected Utils utils;
        protected int myID;

        public PointF GetIntendedVelocity()
        {
            return intendedVelocity;
        }

        public PointF GetIntendedBallVelocity()
        {
            return intendedBallVelocity;
        }

        public void UpdateInformation()
        {
            utils.Update();
        }

        public void SetUtils(Utils u)
        {
            this.utils = u;
        }

        public void SetID(int ID)
        {
            this.myID = ID;
        }

        public abstract void SelectAction();

        public AgentPlayer()
        {
            this.intendedBallVelocity = new PointF(0, 0);
            this.intendedVelocity = new PointF(0, 0);
        }

        protected void goToLocation(PointF location)
        {
            this.intendedVelocity = utils.ComputeVelocity(utils.Locations[myID], location);
        }

        protected void shootToGoal()
        {
            this.intendedBallVelocity = utils.ComputeVelocity(utils.Locations[myID], utils.EnemyGoalCentralPoint);
        }

        protected void passBallToPlayer(int playerID)
        {
            this.intendedBallVelocity = utils.ComputeVelocity(utils.Locations[myID], utils.Locations[playerID]);
        }

        protected int getNearestTeammate()
        {
            return utils.GetNearestPlayer(utils.Locations[myID], Utils.TargetGroup.myPlayers, myID);
        }

        protected PointF getPointBetween(PointF first, PointF second)
        {
            return new PointF((first.X + second.X) / 2, (first.Y + second.Y) / 2);
        }

    }
}
