﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Football
{
    class AgentTeamAI : TeamAI
    {
        protected List<AgentPlayer> players;
        protected List<int> playersIDs;
        protected Utils u;

        public override void setCommands()
        {
            foreach (var item in players)
            {
                item.UpdateInformation();
            }

            foreach (var item in players)
            {
                item.SelectAction();
            }

            for (int i = 0; i < playersIDs.Count; i++)
            {
                if (s.HasBall(playersIDs[i]))
                {
                    s.moveBall(this, playersIDs[i], players[i].GetIntendedBallVelocity());
                }
                s.changeVelocity(this, playersIDs[i], players[i].GetIntendedVelocity());
            }
        }

        public AgentTeamAI(string name, List<AgentPlayer> players)
        {
            this.name = name;
            this.players = players;
            this.playersIDs = new List<int>();
        }

        public override void setSimulator(Simulator sim)
        {
            base.setSimulator(sim);
            u = new Utils(sim, this);
            foreach (var item in this.players)
            {
                item.SetUtils(u);
            }
            playersIDs = sim.getPlayersIDs(this);
            for (int i = 0; i < u.MyPlayersIDs.Count; i++)
            {
                players[i].SetID(u.MyPlayersIDs[i]);
            }
        }

    }
}
